#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
-------------------------------
(c) Universite catholique de Louvain, 2019

Creation : 2019 by LB
Last update : 2019

version MBsysC v1.11.2

-------------------------------
Portable Python interface to MBsysC using Ctypes.

Define the class MbsSolvekin based on the MbsSolvekin structure of MBsysC.

"""

import ctypes

from .forward_decl import MbsSolvekinOptions_c
from .forward_decl import MbsSolvekin_c
from .forward_decl import MbsBuffer_c
from .forward_decl import MbsGrowingBuffer_c
from .forward_decl import MbsAux_c
from .forward_decl import MbsLutRes_c


#==============================================================================
# MbsSolvekin_c
#==============================================================================


MbsSolvekin_c._fields_ = [
        ("options", ctypes.POINTER(MbsSolvekinOptions_c)),
        ("mbs_aux", ctypes.POINTER(MbsAux_c)), 
        ("tsim",    ctypes.c_double),
        ("tindex",  ctypes.c_int),
        ("buffers", ctypes.POINTER(ctypes.POINTER(MbsBuffer_c))),
        ("user_buffer", ctypes.POINTER(MbsGrowingBuffer_c)),
        ("bufferNb", ctypes.c_int),
        ("savedArrays", ctypes.POINTER(ctypes.POINTER(ctypes.c_double))),
        ("savePeriodCounter", ctypes.c_int),
        ("trajectorytype", ctypes.c_int),
        ("q",       ctypes.POINTER(MbsLutRes_c)),
        ("qd",      ctypes.POINTER(MbsLutRes_c)),
        ("qdd",     ctypes.POINTER(MbsLutRes_c))]