#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
-------------------------------
(c) Universite catholique de Louvain, 2019

Creation : 2019 by LB
Last update : 2019

version MBsysC v1.11.2

-------------------------------
Portable Python interface to MBsysC using Ctypes.


Declaration of MBsysC structure related to mbs_buffer.h header file in MBsysC.

"""
import ctypes

from .forward_decl import MbsBuffer_c
from .forward_decl import MbsGrowingBuffer_c
from .forward_decl import AnimInfo_c

#==============================================================================
# MbsBuffer_c
#==============================================================================
MbsBuffer_c._fields_ =[
        ("tx", ctypes.POINTER(ctypes.c_double)),
        ("last_x", ctypes.POINTER(ctypes.c_double)),
        ("last_t", ctypes.c_double), 
        ("flag_no_print", ctypes.c_int),
        ("filename", ctypes.c_char_p),
        ("index", ctypes.c_int),
        ("size", ctypes.c_int),
        ("nx", ctypes.c_int),
        ("id", ctypes.c_int),
        ("anim", ctypes.POINTER(AnimInfo_c))
        ]

#==============================================================================
# MbsGrowingBuffer_c
#==============================================================================
MbsGrowingBuffer_c._fields_ =[
        ("t", ctypes.POINTER(ctypes.c_double)),
        ("X", ctypes.POINTER(ctypes.POINTER(ctypes.c_double))),
        ("names", ctypes.POINTER(ctypes.c_char_p)),
        ("index", ctypes.c_int),
        ("size", ctypes.c_int),
        ("nx", ctypes.c_int),
        ("max_nx", ctypes.c_int),
        ("respath", ctypes.c_char_p)
        ]