# -*- coding: utf-8 -*-
"""
-------------------------------
(c) Universite catholique de Louvain, 2019

Creation : 2019 by O. Lantsoght
Last update : 2019

version MBsysC v1.11.2

-------------------------------
Portable Python interface to MBsysC using Ctypes.

Declaration of MBsysC structure related to LoadXML library.

"""

import ctypes

# importing MBsysC related classes
from .forward_decl import MbsLoadOptions_c
from .forward_decl import MbsLoader_c
from .forward_decl import MbsInfos_c


#==============================================================================
# Global parameter of the current module
#==============================================================================
__DEBUG__ = False


#==============================================================================
# MbsLoadOptions_C
#==============================================================================
MbsLoadOptions_c._fields_ =[
    ("symbolicLib_name",        ctypes.c_char_p),
    ("symbolicLib_path",        ctypes.c_char_p),
    ("userfctLib_name",         ctypes.c_char_p),
    ("userfctLib_path",         ctypes.c_char_p),
    ("no_project_fct",          ctypes.c_int)]


#==============================================================================
# MbsLoader_c
#==============================================================================
MbsLoader_c._fields_ =[
    ("opts",    ctypes.POINTER(MbsLoadOptions_c)),
    ("mbs_infos",     ctypes.POINTER(MbsInfos_c))]
