#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
-------------------------------
(c) Universite catholique de Louvain, 2019

Creation : 2019 by LB
Last update : 2019

version MBsysC v1.11.2

-------------------------------
Portable Python interface to MBsysC using Ctypes.


Declaration of MBsysC structure related to mbs_modal_struct.h header file in MBsysC.

"""

import ctypes

from .forward_decl import MbsModal_c
from .forward_decl import MbsModalOptions_c
from .forward_decl import MbsModalMode_c
from .forward_decl import MbsAux_c
from .forward_decl import MbsSS_c
from .forward_decl import MbsLpk_c


#==============================================================================
# MbsModalOptions_c
#==============================================================================

MbsModalOptions_c._fields_ = [
        ("save2file", ctypes.c_int),
        ("save_mat", ctypes.c_int),    
        ("save_eval", ctypes.c_int),    
        ("save_evec", ctypes.c_int),
        ("save_result", ctypes.c_int),    
        ("save_anim", ctypes.c_int),    
        ("verbose", ctypes.c_int),    
        ("mode_ampl", ctypes.c_double),
        ("compute_uxd", ctypes.c_int),    
        ("compute_JS", ctypes.c_int)    ,
        ("norm_evec", ctypes.c_int),
        ("lpk_itermax", ctypes.c_int),
        ("lpk_relincr", ctypes.c_double),
        ("lpk_absincr", ctypes.c_double),
        ("lpk_equitol", ctypes.c_double),
        ("lpk_lintol", ctypes.c_double),
        ("anim_speed", ctypes.c_int),    
        ("anim_dt", ctypes.c_double),
        ("anim_t", ctypes.c_double),
        ("resfilename", ctypes.c_char_p),
        ("respath", ctypes.c_char_p),
        ("animpath", ctypes.c_char_p)]


MbsModalMode_c._fields_ = [
        ("type", ctypes.c_int),
        ("eval_a", ctypes.c_double),
        ("eval_b", ctypes.c_double),
        ("ksi", ctypes.c_double),
        ("nu_0", ctypes.c_double),
        ("nu", ctypes.c_double),
        ("q_a", ctypes.POINTER(ctypes.c_double)),
        ("q_b", ctypes.POINTER(ctypes.c_double)),
        ("ux_a", ctypes.POINTER(ctypes.c_double)),
        ("ux_b", ctypes.POINTER(ctypes.c_double)),
        ("q_r", ctypes.POINTER(ctypes.c_double)),
        ("q_phi", ctypes.POINTER(ctypes.c_double)),
        ("ux_r", ctypes.POINTER(ctypes.c_double)),
        ("ux_phi", ctypes.POINTER(ctypes.c_double)),
        ("ever_r", ctypes.POINTER(ctypes.c_double)),
        ("ever_phi", ctypes.POINTER(ctypes.c_double))
        ]


MbsModal_c._fields_ = [
        ("options", ctypes.POINTER(MbsModalOptions_c)),
        ("aux", ctypes.POINTER(MbsAux_c)), 
        ("lpk", ctypes.POINTER(MbsLpk_c)),
        ("ss", ctypes.POINTER(MbsSS_c)),
        ("Bvuc", ctypes.POINTER(ctypes.POINTER(ctypes.c_double))),
        ("q_saved", ctypes.POINTER(ctypes.c_double)),
        ("qd_saved", ctypes.POINTER(ctypes.c_double)),
        ("qdd_saved", ctypes.POINTER(ctypes.c_double)),
        ("Qq_saved", ctypes.POINTER(ctypes.c_double)),
        ("nx", ctypes.c_int),
        ("eval_a", ctypes.POINTER(ctypes.c_double)),
        ("eval_b", ctypes.POINTER(ctypes.c_double)),
        ("evec_a", ctypes.POINTER(ctypes.POINTER(ctypes.c_double))),
        ("evec_b", ctypes.POINTER(ctypes.POINTER(ctypes.c_double))),
        ("evec_r", ctypes.POINTER(ctypes.POINTER(ctypes.c_double))),
        ("evec_phi", ctypes.POINTER(ctypes.POINTER(ctypes.c_double))),
        ("nMode", ctypes.c_int),
        ("modeList", ctypes.POINTER(MbsModalMode_c)),
        ("iModeSorted", ctypes.POINTER(ctypes.c_int))
        ]