# -*- coding: utf-8 -*-
"""
-------------------------------
(c) Universite catholique de Louvain, 2019

Creation : 2019 by O. Lantsoght
Last update : 2019

version MBsysC v1.11.2

-------------------------------
Portable Python interface to MBsysC using Ctypes.

Declaration of MBsysC structure related to mbs_part.h file in MBsysC.

"""

import ctypes

# importing MBsysC related classes
from .forward_decl import MbsPartOptions_c
from .forward_decl import MbsPart_c


#==============================================================================
# Global parameter of the current module
#==============================================================================
__DEBUG__ = False


#==============================================================================
# MbsPartOptions_c
#==============================================================================
MbsPartOptions_c._fields_ = [
        ("rowperm", ctypes.c_int),
        ("visualise",  ctypes.c_int),
        ("drivers",  ctypes.c_int),
        ("verbose",  ctypes.c_int),
        ("clearmbsglobal",  ctypes.c_int),
        ("random_amplitude", ctypes.c_double)
        ]


#==============================================================================
# MbsPart_c
#==============================================================================
MbsPart_c._fields_ = [
        ("options", ctypes.POINTER(MbsPartOptions_c)),
        ("nqu", ctypes.c_int),
        ("ind_qu",  ctypes.POINTER(ctypes.c_int)),
        ("nqv",  ctypes.c_int),
        ("ind_qv",  ctypes.POINTER(ctypes.c_int)),
        ("nhu",  ctypes.c_int),
        ("ind_hu",  ctypes.POINTER(ctypes.c_int)),
        ("nhv",  ctypes.c_int),
        ("ind_hv",  ctypes.POINTER(ctypes.c_int)),
        ("q_closed",  ctypes.POINTER(ctypes.c_double))
        ]