# -*- coding: utf-8 -*-
"""
-------------------------------
(c) Universite catholique de Louvain, 2020

Author : Robotran Team
Last update : 2020

-------------------------------
Portable Python interface to the MBS addon Tire Ground contact for Cars.

Requirements
------------
This interface requires the package MBsysPy to be loaded previously.

Functions
---------

    tgc_car_kine_wheel
    tgc_bakker_contact

"""
import sys

#==============================================================================
# Check for dependancies
#==============================================================================
if "MBsysPy" not in sys.modules:
    raise ImportError("The module 'mbs_tgc' requires the library 'libMBsysC_utilities'"
                      "loaded with the package 'MBsysPy'.\n The package 'MBsysPy' must"
                      " be imported prior to 'mbs_tgc'.")

#==============================================================================
# Import modules
#==============================================================================
from .mbs_tgc import *